4Suite™ API Documentation

# ► Module Ft.Server.Common.ClAuthenticate

Repository client (4ss, 4ss_manager) common login routines
Copyright 2004 Fourthought, Inc. (USA).
Detailed license and copyright information: http://4suite.org/COPYRIGHT
Project home, documentation, distributions: http://4suite.org/

Classes: Error, FtServerAuthenticationException, PasswordFileManager |  |  |  | Functions: GetHostName, GetPass, GetPort, GetUserName, HashPasswd, UserAuthenticate

## Classes

class Error

### Fields

INTERNAL_ERROR = 1
PASSWDFILE_UNDEFINED = 10

class FtServerAuthenticationException(Ft.Server.FtServerBaseException)

### Methods inherited from class Ft.Server.FtServerBaseException

__init__

### Methods inherited from class Ft.FtException

__getattr__, __repr__, __str__

### Methods inherited from class exceptions.Exception

__getitem__

### Fields

MessageSource = <module 'Ft.Server.Common.MessageSource' from 'b...E-p2-i386-2.4/Ft/Server/Common/MessageSource.py'>

class PasswordFileManager

### Methods

__init__(self)
getUserEntry(self, userName)
Gets the password hash, hostname, and port for the given username in the password file. Returns (None, None, 0) if there is no entry for the username, or if the password file is not readable.
setUserEntry(self, userName, passwdHash, hostName, port)
Stores the password hash, hostname, and port for the given username in the password file, overwriting any existing entry for the user. Raises an exception if any of the values are inappropriate for storage or if there was a problem storing them in the file.

## Functions

GetHostName(prompt='Host: ')
Prompts for a hostname on stderr.
GetPass(prompt='Password: ')
Wrapper for getpass.getpass(), with the only difference being that on Unix, the prompt will be sent to stderr rather than stdout.
GetPort(prompt='Port: ')
Prompts for a port on stderr.
GetUserName(prompt='Username: ', emptyOK=True)
Prompts for a username on stderr. Keeps prompting if emptyOK is false and no username is entered.
HashPasswd(passwd)
Returns a hash of the given password string.
UserAuthenticate(options=None, prompt='User', promptOnly=0)
Obtains a username and password hash, prompting for them, if necessary. Returns a tuple (username, password), which can be (None, None).
Username sources normally checked are, in order:
1. the options dictionary;
2. the agent referenced in the FTSS_AGENT environment variable;
3. the FTSS_USERNAME environment variable;
4. a prompt for user input.
Password sources normally checked are, in order:
1. the password file referenced in environment var. FTSS_PASSWORD_FILE;
2. the password file $HOME/.4ss.passwd or %WINDIR%\.4ss.passwd;
3. the password file referenced in the deprecated environment variable
FTSERVER_PASSWORD_FILE;
4. a prompt for user input.
Optional arguments:
options - a dictionary of options parsed from the command line
(see FancyGetOpt). The key 'anonymous' is taken to indicate that no
authentication is necessary and (None, None) should be returned.
If the key 'username' is present, the associated value is returned as
the username and no other potential sources for username are checked.
prompt - if the user is to be prompted for their username, this is the
string that indicates the type of user to be mentioned in the prompt.
It is 'User' or 'Manager', typically.
promptOnly - if set, this flag forces the username and password to be
obtained by prompting the user; other sources are not checked.